Download it now!
Bug 112042 - idxf import filter not handling some text
Summary: idxf import filter not handling some text
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: filters and storage (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2017-08-26 18:02 UTC by V Stuart Foote
Modified: 2020-06-02 20:19 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments
clip of attachment 109803 opened in Draw (15.83 KB, image/png)
2017-08-26 20:35 UTC, V Stuart Foote
Details
DXF opened in Irfanview, showing Text annotation (110.21 KB, image/png)
2017-08-26 22:36 UTC, V Stuart Foote
Details
clip of DXF opened with defaults in AutoDesk 2016 (65.97 KB, image/png)
2017-08-26 23:07 UTC, V Stuart Foote
Details
clip from DXF opened in CorelDraw 2017 (34.27 KB, image/png)
2017-08-26 23:54 UTC, V Stuart Foote
Details

Note You need to log in before you can comment on or make changes to this bug.
Description V Stuart Foote 2017-08-26 18:02:47 UTC
attachment 109803 [details] (SolidWorks showing ACADVER AC1015) from bug 86206 drops all its text with idxf import filter.

Looking at other bugs with DXF attachements, notice some of the more intricate DXF images are not very well handled by the idxf filter.
Comment 1 V Stuart Foote 2017-08-26 20:33:35 UTC
Some other DXF attachments in TDF BZ for any desired testing

attachment 53862 from bug 43082 (large drawing template with legend, all text well rendered).

attachment 79061 [details] from bug 64400 (truck chassis idxf filter chokes on it, just an bounding box is rendered in Draw, no text shows).

attachment 93153 [details] from bug 74299 (complex multi-axis graphs, Mike K had tweaked the text handling for these, but the bounding box is wrong on filter insert/open).

attachment 113990 [details] from bug 89901 (another truck chassis--this one is huge, idxf filter chokes on it and just a couple of line elements are rendered, even Irfanview chokes on it, but opens cleanly into CorelDraw 2017).

attachment 118567 [details] from bug 94067 (screw & plug adapter, text and other elements rendered pretty well in Draw insert/open, but suffers from dashed line export to SVG issue of bug 86206).

Tested on Windows 10 builds of 5.4.1.1 and 6.0.0a1+
Comment 2 V Stuart Foote 2017-08-26 20:35:26 UTC
Created attachment 135806 [details]
clip of attachment 109803 [details] opened in Draw
Comment 3 Jean-Baptiste Faure 2017-08-26 21:31:27 UTC
I get the same view in LO 5.4.0 (ubuntu) but that don't show if something is missing.
Please, could you attach a screencopy of what should be seen or describe a mean to check if something is missing in the view by Draw.

Best regards. JBF
Comment 4 V Stuart Foote 2017-08-26 22:36:19 UTC
Created attachment 135808 [details]
DXF opened in Irfanview, showing Text annotation
Comment 5 V Stuart Foote 2017-08-26 22:42:49 UTC
Just checked a Windows 3.3.0 build
LibreOffice 3.3.0 
OOO330m19 (Build:6)
tag libreoffice-3.3.0.4

Text was already missing at this point, so inherited from OOo.
Comment 6 V Stuart Foote 2017-08-26 23:07:02 UTC
Created attachment 135809 [details]
clip of DXF opened with defaults in AutoDesk 2016

Also, the LO rendering from 3.3.0 -> 6.0.0alpha1+ picks up most of the dimension lines as dashed, rather than solid as IrfanView (BabaCAD4Image plugin). 

Have to check again what CorelDraw 2017 seemed the labeling was more complete than with the AutoDesk 2016 clip.
Comment 7 V Stuart Foote 2017-08-26 23:54:48 UTC
Created attachment 135811 [details]
clip from DXF opened in CorelDraw 2017

in CorelDraw 2017 text annotation and mixed line types (dashed, solid) are present.
Comment 8 Mike Kaganski 2017-08-27 06:58:26 UTC
The dimensions in AutoCad drawings don't have their readings recorded in the file. Their readings are created at runtime based on the measurement, and formatted according to rules stored in dimension text (e.g., the text may simply override the measurement and output only static text, or pre-or postpone the measurement with static texts). The value measured may be taken in 3D, or in 2D based in current viewport. The problem is seen in IrfanView and CorelDraw, which ignore all customizations of the measurement formatting and try to calculate the values themselves.

I am not sure that what IrfanView (CorelDraw) do is any better than what Draw does.
Comment 9 Jean-Baptiste Faure 2017-08-27 07:32:48 UTC
(In reply to V Stuart Foote from comment #4)
> Created attachment 135808 [details]
> DXF opened in Irfanview, showing Text annotation

Thank you very much. :-)

Best regards. JBF
Comment 10 V Stuart Foote 2017-08-27 12:30:41 UTC
(In reply to Mike Kaganski from comment #8)
> The dimensions in AutoCad drawings don't have their readings recorded in the
> file. Their readings are created at runtime based on the measurement, and
> formatted according to rules stored in dimension text (e.g., the text may
> simply override the measurement and output only static text, or pre-or
> postpone the measurement with static texts). The value measured may be taken
> in 3D, or in 2D based in current viewport. The problem is seen in IrfanView
> and CorelDraw, which ignore all customizations of the measurement formatting
> and try to calculate the values themselves.
> 
> I am not sure that what IrfanView (CorelDraw) do is any better than what
> Draw does.

OK makes sense. And guess that means what shows as text in Draw must be present as static text in the DXF or it would not be rendered. Would expect annotation to be static, but most dimensioning in a CAD file would be intentionally dynamic and only have place holders. Which seems to be true with the drawing file from comment 0 opened into AutoDesk.

So, can we do better with the dimensioning/dynamic text or is it a lost cause that should just be noted in help for the filter?
Comment 11 Mike Kaganski 2017-08-27 17:00:07 UTC
(In reply to V Stuart Foote from comment #10)
> So, can we do better with the dimensioning/dynamic text or is it a lost
> cause that should just be noted in help for the filter?

Of course, we can do better. DXF has a good documentation, and there is reference implementation (closed-source) which may be consulted when some details need clarification wrt correct work. But given my past experience as AutoCAD user/programmer/teacher I can say that's rather big chunk of work. (Personally I don't have plans working on this.)
Comment 12 V Stuart Foote 2017-08-27 17:57:38 UTC
(In reply to Mike Kaganski from comment #11)
> Of course, we can do better. DXF has a good documentation, and there is
> reference implementation (closed-source) which may be consulted when some
> details need clarification wrt correct work. But given my past experience as
> AutoCAD user/programmer/teacher I can say that's rather big chunk of work.
> (Personally I don't have plans working on this.)

Fair enough :-)

Anyhow, I poked around in the LibreCAD project. Kind of wonder if their libdxfrw spinoff project might be worth investigating as a drop-in replacement for our idxf multipart import filter feed to dxf2mtf.

Supports both ASCII and binary DXF through ACAD 2015, could add support for DWG. And basis to write back out to DXF?

=-ref-=
https://sourceforge.net/p/libdxfrw/home/Home/
Comment 13 QA Administrators 2018-08-28 02:42:35 UTC Comment hidden (obsolete)
Comment 14 Xisco Faulí 2020-06-02 20:19:10 UTC
Still reproducible in

Version: 7.0.0.0.beta1+
Build ID: 2506d8221dd940dfd93d3d7c183430ba6ba3089d
CPU threads: 4; OS: Linux 4.19; UI render: default; VCL: gtk3
Locale: en-US (en_US.UTF-8); UI: en-US
Calc: threaded